=== tutorial/Makefile ===
all:
	pandoc --toc --css bootstrap.css --template template.html -s -S bedtools.md -o bedtools.html
	pandoc --css bootstrap.css --template template.class.html -s -S answers.md -o answers.html
