=== debian/changelog ===
bedtools (2.30.0+dfsg-1) unstable; urgency=medium

  [ Étienne Mollier ]
  * Team upload.
  * New upstream version 2.30.0+dfsg.
  * Refresh 2to3.patch and hardening patch.
  * Remove test related patches, 32-bit-fixes.patch and spelling patch;
    applied upstream.
  * Do not include htsutil as a side test program in bedtools anymore;
    the test tool is inlined as subcommand to reduce memory footprint.

  [ John Marshall ]
  * Add htsutil patch to implement the bedtools htsutil subcommand.

  [ Étienne Mollier ]
  * d/rules: set $htsutil to use the bedtools htsutil subcommand.
  * d/t/run-unit-test: use the bedtools htsutil subcommand.

 -- Étienne Mollier <etienne.mollier@mailoo.org>  Wed, 27 Jan 2021 17:26:26 +0100

bedtools (2.29.2+dfsg-6) unstable; urgency=medium

  * Team upload.
  * Repair broken link in run-unit-test script; fixes autopkgtest regression.

 -- Étienne Mollier <etienne.mollier@mailoo.org>  Sun, 17 Jan 2021 12:11:39 +0100

bedtools (2.29.2+dfsg-5) unstable; urgency=medium

  * Delete standard debian/gbp.conf
  * Revert deletion of test binary htsutil since it is needed to replace
    samtools that's not working any more for this purpose
  * Move htsutil tool to bedtools package
    Closes: #978679

 -- Andreas Tille <tille@debian.org>  Mon, 04 Jan 2021 13:01:58 +0100

bedtools (2.29.2+dfsg-4) unstable; urgency=medium

  [ Michael R. Crusoe ]
  * Team upload.
  * Remove the need for samtools via patch from upstream.
  * Include patch from Bernhard Übelacker to fix 32-bit builds. TODO: the
    autopkgtests do not yet pass on i386 (and likely neither on other 32-bit
    archs).
    Closes: #955403
  * debhelper-compat 13 (routine-update)
  * Add salsa-ci file (routine-update)
  * Rules-Requires-Root: no (routine-update)

  [ Andreas Tille ]
  * Fix permissions of .sam files
  * Delete test binary to make sure it will not be installed
  * DEP3
  * Standards-Version: 4.5.1 (routine-update)

 -- Andreas Tille <tille@debian.org>  Sun, 20 Dec 2020 19:03:35 +0100
