=== debian/control ===
Source: bedtools
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Charles Plessy <plessy@debian.org>,
           Andreas Tille <tille@debian.org>
Section: science
Priority: optional
Build-Depends: debhelper-compat (= 13),
               python3,
               zlib1g-dev,
               libbz2-dev,
               liblzma-dev
Standards-Version: 4.5.1
Vcs-Browser: https://salsa.debian.org/med-team/bedtools
Vcs-Git: https://salsa.debian.org/med-team/bedtools.git
Homepage: https://github.com/arq5x/bedtools2
Rules-Requires-Root: no

Package: bedtools
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends}
Conflicts: filo
Provides: filo
Replaces: filo
Description: suite of utilities for comparing genomic features
 The BEDTools utilities allow one to address common genomics tasks such as
 finding feature overlaps and computing coverage. The utilities are largely
 based on four widely-used file formats: BED, GFF/GTF, VCF, and SAM/BAM. Using
 BEDTools, one can develop sophisticated pipelines that answer complicated
 research questions by streaming several BEDTools together.
 .
 The groupBy utility is distributed in the filo package.

Package: bedtools-test
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Suggests: bedtools
Description: test data for the bedtools package
 Test data for the BEDTools suite of utilities for comparing genomic features.
 It is distributed in a separate package because it is large and
 architecture-independent.
