## bedtools 2.31.0+dfsg

=== debian/changelog ===
bedtools (2.31.0+dfsg-1) unstable; urgency=medium

  * New upstream version
  * Standards-Version: 4.6.2 (routine-update)
  * remove_barski_binding_site.png.patch: unfuzz.
  * 2to3.patch: refresh.
  * 2to3.patch: declare forwarding not-needed.
    Upstream looks to assume compatibility with both python and python3.
  * 2to3.patch: remove further occurrences of python.
    There are some tests and some documentation referring to the
    unversioned python, which in Debian is by default python2.
  * hardening patch: unfuzz.
  * htsutil patch: unfuzz.
  * gcc-13.patch: add; fix ftbfs with gcc-13.
    Thanks to David Seifert (Closes: #1037588)
  * d/control: bedtools-test depend on python3.

 -- Étienne Mollier <emollier@debian.org>  Fri, 23 Jun 2023 22:57:16 +0200

bedtools (2.30.0+dfsg-3) unstable; urgency=medium

  * Do not use ulimit in test
    Closes: #1034349
  * Override false positive (see lintian bug #1017966)

 -- Andreas Tille <tille@debian.org>  Thu, 13 Apr 2023 14:12:15 +0200

bedtools (2.30.0+dfsg-2) unstable; urgency=medium

  [ Steffen Möller ]
  * Update metadata - indent, added ref to guix

  [ Étienne Mollier ]
  * d/control: add myself to uploaders
  * d/watch: fix broken link to github

  [ Andreas Tille ]
  * Standards-Version: 4.6.0 (routine-update)

 -- Andreas Tille <tille@debian.org>  Thu, 02 Sep 2021 06:54:44 +0200
