=== debian/control ===
--- 
+++ 
@@ -1,7 +1,8 @@
 Source: bedtools
 Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
 Uploaders: Charles Plessy <plessy@debian.org>,
-           Andreas Tille <tille@debian.org>
+           Andreas Tille <tille@debian.org>,
+           Étienne Mollier <emollier@debian.org>
 Section: science
 Priority: optional
 Build-Depends: debhelper-compat (= 13),
@@ -9,7 +10,7 @@
                zlib1g-dev,
                libbz2-dev,
                liblzma-dev
-Standards-Version: 4.5.1
+Standards-Version: 4.6.2
 Vcs-Browser: https://salsa.debian.org/med-team/bedtools
 Vcs-Git: https://salsa.debian.org/med-team/bedtools.git
 Homepage: https://github.com/arq5x/bedtools2
@@ -34,7 +35,7 @@
 Package: bedtools-test
 Architecture: all
 Multi-Arch: foreign
-Depends: ${misc:Depends}
+Depends: ${misc:Depends}, python3
 Suggests: bedtools
 Description: test data for the bedtools package
  Test data for the BEDTools suite of utilities for comparing genomic features.
