## bedtools 2.31.1+dfsg

=== Makefile ===
--- 
+++ 
@@ -22,6 +22,8 @@
 SRC_DIR	= src
 
 CXX     = g++
+
+PYTHON ?= $(shell python --version >/dev/null 2>&1 && echo "python" || echo python3)
 
 ifeq ($(DEBUG),1)
 BT_CPPFLAGS = -DDEBUG -D_DEBUG -D_FILE_OFFSET_BITS=64 -DWITH_HTS_CB_API $(INCLUDES)
@@ -113,7 +115,8 @@
 				$(SRC_DIR)/utils/GenomeFile \
 				$(SRC_DIR)/utils/RecordOutputMgr \
 				$(SRC_DIR)/utils/ToolBase \
-				$(SRC_DIR)/utils/driver
+				$(SRC_DIR)/utils/driver \
+				$(SRC_DIR)/utils/BamTools
 
 INCLUDES =		$(addprefix -I,$(SUBDIRS) $(UTIL_SUBDIRS)) \
 				-I$(SRC_DIR)/utils/BamTools/include \
@@ -189,7 +192,7 @@
 
 $(BIN_DIR)/intersectBed: | $(BIN_DIR)
 	@echo "- Creating executables for old CLI."
-	@python scripts/makeBashScripts.py
+	@$(PYTHON) scripts/makeBashScripts.py
 	@chmod +x bin/*
 	@echo "done."
