=== debian/changelog ===
bedtools (2.31.1+dfsg-2) unstable; urgency=medium

  * d/clean: new: remove test/getfasta/t.fa.gz.gzi. (Closes: #1043957)

 -- Étienne Mollier <emollier@debian.org>  Mon, 04 Dec 2023 20:13:11 +0100

bedtools (2.31.1+dfsg-1) unstable; urgency=medium

  * New upstream version 2.31.1+dfsg
  * gcc-13.patch: remove: applied upstream.

 -- Étienne Mollier <emollier@debian.org>  Fri, 24 Nov 2023 12:10:46 +0100

bedtools (2.31.0+dfsg-2) unstable; urgency=medium

  * gcc-13.patch: fixed upstream by different change.
    The Applied-Upstream field is set accordingly to point to PR 1067.
  * d/rules: use sse for floating point calculations.
    This fixes bedtools "intersect" test failures during build time.
    This change is brought for consistency with htslib's own settings.
    While this is an architecture baseline violation, the alternative
    is no htslib support at all for the i386 distribution, since it
    fails its own test suite with anything else than sse for floating
    point calculations. (Closes: #1055414)
  * d/control: depend on python3:any per M-A hint.

 -- Étienne Mollier <emollier@debian.org>  Sat, 18 Nov 2023 16:34:59 +0100
