=== debian/control ===
--- 
+++ 
@@ -6,7 +6,7 @@
 Section: science
 Priority: optional
 Build-Depends: debhelper-compat (= 13),
-               python3,
+               python3:any,
                zlib1g-dev,
                libbz2-dev,
                liblzma-dev
