=== debian/rules ===
--- 
+++ 
@@ -6,7 +6,7 @@
 
 include /usr/share/dpkg/default.mk
 ifneq (,$(filter $(DEB_HOST_ARCH),i386 kfreebsd-i386 hurd-i386))
-  export DEB_CXXFLAGS_MAINT_APPEND=-ffloat-store
+  export DEB_CXXFLAGS_MAINT_APPEND=-msse -mfpmath=sse
 endif
 
 %:
