=== debian/watch ===
version=4
opts="repacksuffix=+dfsg,dversionmangle=auto,repack,compression=xz" \
	https://github.com/arq5x/bedtools2/tags \
	(?:.*?/)?v?(\d[\d.]*)\.tar\.gz
